/*
 * Copyright 2016 - 2022 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <ox/std/error.hpp>
#include <ox/std/memory.hpp>
#include <ox/std/vector.hpp>

namespace nostalgia::studio {

class UndoCommand {
	public:
		virtual ~UndoCommand() noexcept = default;
		virtual void redo() noexcept = 0;
		virtual void undo() noexcept = 0;
};

class UndoStack {
	private:
		ox::Vector<ox::UniquePtr<UndoCommand>> m_stack;
		std::size_t m_stackIdx = 0;

	public:
		void push(UndoCommand *cmd) noexcept;

		void redo() noexcept;

		void undo() noexcept;
};

}